
#include <msp430.h> 
#include "tmag5170.h"















int main(void)
{
WDTCTL = WDTPW | WDTHOLD; // stop watchdog timer



WDTCTL = WDTPW | WDTHOLD;   // stop watchdog timer

   // Setup A0 SPI
   UCA0CTLW0 |= UCSWRST;       //put A0 into SW reset

   UCA0CTLW0 |= UCSSEL__SMCLK; // Choose SMCLK = 1 MHz
   UCA0BRW = 10;               // Set prescale= 10 to get SCLK = 100kHz

   UCA0CTLW0 |= UCSYNC;        // put A0 into SPI
   UCA0CTLW0 |= UCMST;         // Set as a master

   UCA0CTLW0 |=UCMODE1;        // UCMODE = 10 = 4-pin with ACTIVE LOW STE
   UCA0CTLW0 &= ~UCMODE0;

   UCA0CTLW0 |= UCSTEM;        // use STE as normal enable

   // Configure ports
       P2DIR &= ~BIT4;             // Make p 2.4 an input (SW1)
       P2REN |= BIT4;              // Enable resistor
       P2OUT |= BIT4;              // Make resistor a pull up
       P2IES |= BIT4;              //Sensitive to H-to-L

       P1SEL1 &= ~BIT6;            // P1.6 = SCLK (01)
       P1SEL0 |= BIT6;

       P1SEL1 &= ~BIT4;            // P1.4 = SIMO (01)
       P1SEL0 |= BIT4;

       P1SEL1 &= ~BIT5;            // P1.5 = SOMI (01)
       P1SEL0 |= BIT5;

       PM5CTL0 &= ~LOCKLPM5;       // Turn on I/O

       UCA0CTLW0 |= UCSWRST;       // Take out of SW Reset

       // Enable IRQs
       P2IE |= BIT4;               // Enable P2.4 IRQ
       P2IFG &= ~BIT4;             // Clear flag

       UCA0IE |= UCTXIE;           // Enable A0 Tx IRQ
       UCA0IFG &= ~UCTXIFG;         // Clear flag

       __enable_interrupt();       // Enable global








       //Sensor's memory register addresses:

       const int DEVICE_CONFIG = 0x00; //0x0 is used for writes, should really handle this in the read command

       const int SENSOR_CONFIG = 0x01;

       const int SYSTEM_CONFIG = 0x02; // this is where we can switch to the 12bit XY sampling mode

       const int TEST_CONFIG = 0x0F;

       const int X_CH_RESULT = 0x89; //0x8 is used for reads, should really handle this in the write command

       const int Y_CH_RESULT = 0x8A;

       const int Z_CH_RESULT = 0x8B;

       const int TEMP_RESULT = 0x8C;

       const int range = 50;



       const int chipSelectPin = 13;





const uint32_t magArray[16] = {1518500250,1358187913,1317635818,1307460871,
                               1304914694,1304277995,1304118810,1304079014,
                               1304069065,1304066577,1304065955,1304065800,
                               1304065761,1304065751,1304065749,1304065748};
const uint32_t atanArray32[16] = {536870912,316933406,167458907,85004756,42667331,
                                  21354465,10679838,5340245,2670163,1335087,667544,
                                  333772,166886,83443,41722,20861};



//****************************************************************************
//! This variable tracks the state of the SYSTEM_CONFIG register (0x02)
//! Since any special read state cannot read out registers when called,
//! keeping track of the SYSTEM_CONFIG register is needed in order to
//! switch to and from normal read mode without altering other bits besides
//! DATA_TYPE's (0x028-6).
//!
//! The macro 'DATA_TYPE_RESULTS' defined in the header can be used to access
//! the DATA_TYPE bits contained in the stored register.
//!
//! This variable also must be initialized using a function like the one
//! below before the rest of any code implementation using the given example
//! functions can work.
//****************************************************************************
static uint16_t SYSTEM_CONFIG_stored = 0;
#define DATA_TYPE_RESULTS    ((SYSTEM_CONFIG_stored & ~(SYSTEM_CONFIG_DATA_TYPE_MASK)) >> 6)

#ifdef      GLOBAL_CRC_ERROR_VAR_ENABLED
            uint8_t crc_error_occurence = 0;
#endif

#ifdef      GLOBAL_INPUT_ERROR_VAR_ENABLED
            uint8_t fcn_input_error_occurence = 0;
#endif





            //****************************************************************************
            //! Initialization function
            //!
            //! This function MUST be ran at the beginning of any implementation using this
            //! example code. This is needed because the SYSTEM_CONFIG register is needed to
            //! be tracked and updated accordingly to prevent losing track of the DATA_TYPE
            //! in use by the device.
            //!
            //! If CRC is being disabled per the header definition being enabled, then this
            //! function also sends the command to disable CRC on the device as well.
            //! NOTE: if CRC is being disabled then the RESET_DEVICE_IN_STARTUP should be
            //! enabled as well
            //****************************************************************************
void TMAG5170startup() {
    // (OPTIONAL) Provide additional delay time for power supply settling
    delay_ms(50);

#ifdef RESET_DEVICE_IN_STARTUP
    // SYSTEM_CONFIG_stored will be set to default in this function
    resetDevice();
#else
    // The default implementation of this initialize function is resetting only
    // the SYSTEM_CONFIG register and leaving the other registers unchanged.
    writeToRegister( SYSTEM_CONFIG_ADDRESS, SYSTEM_CONFIG_DEFAULT );
    SYSTEM_CONFIG_stored = SYSTEM_CONFIG_DEFAULT;
#endif

#ifdef DISABLE_CRC_IN_STARTUP
    // Sends command to disable CRC verfication and calculation on device-side
    // MUST be called first in implementation for commands from other functions
    // to be accepted when DISABLE_CRC_IN_STARTUP is used.
    uint8_t dataTx[4] = {0x0F,0x00,0x04,0x07};
    uint8_t dataRx[4] = {0};
    sendAndReceiveFrame(dataTx,dataRx);
#endif
}



//****************************************************************************
//! Send and Receive Frame
//!
//! Takes in the frame to transmit by SPI and the array to put the received frame in
//!
//! dataTx[4] - unint8_t array of length 4 containing the bytes frame to transmit
//!             ordered with CRC-containing byte last
//! dataRx[4] - unint8_t array of length 4 of zeroes on input, will have the received
//!             frame bytes assigned to it ordered with CRC bits last
//****************************************************************************
void sendAndReceiveFrame(uint8_t dataTx[], uint8_t dataRx[])
{

#ifdef DISABLE_CRC_IN_STARTUP
    // When CRC is disabled upon system initialization, the need to calculate
    // the dataTx CRC for the TMAG5170 to accept commands is gone at the risk
    // of transmission errors being passed through.

    spiSendReceiveArrays(dataTx, dataRx, TMAG5170_FRAME_NUM_BYTES);

    // Check if SYSTEM_CONFIG was written to and update SYSTEM_CONFIG_stored if so
    if ( dataTx[0] == SYSTEM_CONFIG_ADDRESS ) SYSTEM_CONFIG_stored = (dataTx[1] << 8) | dataTx[2];
    SYSTEM_CONFIG_stored &= ~(0xC818); // Reserved bits cannot be 1, this ensures the
                                       // stored variable doesn't have them changed
#else
    // When CRC is enabled (it is by default), the CRC must be calculated and
    // included in dataTx for the TMAG5170 to accept commands.

    uint8_t crc = calculateCRC( dataTx );
    dataTx[3] = dataTx[3] | crc;

    spiSendReceiveArrays(dataTx, dataRx, TMAG5170_FRAME_NUM_BYTES);

    // The TMAG5170 also calculates the CRC for the frame it sends back to its
    // MCU. The TMAG5170 will purposely return a bad CRC if it received a
    // transmitted command with a bad CRC as well. Verifying the CRC of dataRx
    // helps confirm if dataTx was received successfully and if dataRx is valid.
    if (verifyCRC(dataRx) == 0)
    {
        // Without GLOBAL_CRC_ERROR_VAR_ENABLED defined or another error response
        // implemented, this function will not give any indication that the
        // received data has an error

        #ifdef  SEND_RECIEVE_REDUNDANCY_ENABLED

        for ( i = 0; i<4; i++ ) { dataRx[i] = 0 };
        spiSendReceiveArrays(dataTx, dataRx, TMAG5170_FRAME_NUM_BYTES);
        if ( verifyCRC(dataRx) )
        {
            // Check if SYSTEM_CONFIG was written to and update SYSTEM_CONFIG_stored if so
            if ( dataTx[0] == SYSTEM_CONFIG_ADDRESS ) SYSTEM_CONFIG_stored = (dataTx[1] << 8) | dataTx[2];
            SYSTEM_CONFIG_stored &= ~(0xC818); // Reserved bits cannot be 1, this ensures the
                                               // stored variable doesn't have them changed
            return;
        }

        #endif

        #ifdef  GLOBAL_CRC_ERROR_VAR_ENABLED
        crc_error_occurence = 1; // If redundancy is enabled too, the error bit
                                 // only flips if both sent TXs receive bad CRCs
        #endif

        return; // If a received data CRC error is detected, SYSTEM_CONFIG_stored
                // will not be updated under the assumption that whatever command
                // sent was not accepted.
    }

    // Check if SYSTEM_CONFIG was written to and update SYSTEM_CONFIG_stored if so
    if ( dataTx[0] == SYSTEM_CONFIG_ADDRESS ) SYSTEM_CONFIG_stored = (dataTx[1] << 8) | dataTx[2];
    SYSTEM_CONFIG_stored &= ~(0xC818); // Reserved bits cannot be 1, this ensures the
                                       // stored variable doesn't have them changed
#endif
}


//****************************************************************************
//! Full Read Function for Normal Data Mode (DATA_TYPE = 000b)
//!
//! Takes in an output array of length 2, address to read from, and CMD bits to send along,
//! then creates the dataTx array and calls the sendAndReturnFrame function, interpreting
//! dataRx and putting the read register in output[0] and status bits in output[1]
//!
//! output[2] - empty uint16_t array of length 2, output[0] will be assigned the returned register
//!             at the given address, output[1] will be assigned the returned status bits.
//! address   - uint8_t value from 0x00 to 0x14 containing the register address to read from
//! cmd_bits  - uint8_t value from 0x00 to 0x03 containing the CMD0 and CMD1 bits that will be sent
//!             in dataTx. LSB is CMD0, next bit is CMD1. (see header file or datasheet pg. 29 for CMD functions)
//****************************************************************************
void normalRead( uint16_t output[], uint8_t address, uint8_t cmd_bits )
{
    // Check that the input address is in range
    assert(address < NUM_REGISTERS);

    // Build TX and RX byte arrays
    uint8_t dataTx[4] = { 0 };
    uint8_t dataRx[4] = { 0 };

    // MSB is 1 for READ command
    dataTx[0] = (address | 0x80);
    dataTx[1] = 0x00;
    dataTx[2] = 0x00;
    dataTx[3] = cmd_bits << 4;

    sendAndReceiveFrame(dataTx, dataRx);
    output[0] = (dataRx[1] << 8) | dataRx[2];
    output[1] = (dataRx[0] << 4) | (dataRx[3] >> 4);
}


//****************************************************************************
//! Get and return the *_CH_RESULT (or TEMP_RESULT for T) register for an axis/measurement
//!
//! These functions explicitly return the unsigned 16-bit register of their respective
//! measurement address.
//****************************************************************************

//unit16_t getXresult() { return normalReadRegister(X_CH_RESULT_ADDRESS); }
//uint16_t getYresult() { return normalReadRegister(Y_CH_RESULT_ADDRESS); }
//uint16_t getZresult() { return normalReadRegister(Z_CH_RESULT_ADDRESS); }

//OU

//****************************************************************************
//! Get Magnetic Results Registers (Normal Read Mode)
//!
//! In 32-bit normal read mode:
//! Takes in a size 3 array of int16_t values and assigns it the the
//! three *_CH_RESULT registers. (order XYZ)
//!
//! INPUT ARRAY MUST BE OF LENGTH 3
//!
//! NOTE: The uint16_t variables returned by the get*result functions are casted
//! into int16_t variables for use with the other provided functions that take
//! signed integers.
//!
//! DOES NOT WORK IN SPECIAL READ MODE [DATA_TYPE field at 0x028-6 does not equal 000b]
//****************************************************************************
void getMagResultsRegistersNrml( int16_t meas_arr[] )
{
    meas_arr[0] = (int16_t) getXresult();
    meas_arr[1] = (int16_t) getYresult();
    meas_arr[2] = (int16_t) getZresult();
}




//****************************************************************************
//! Get Magnetic Measurements in mT (Normal Read Mode)
//!
//! In 32-bit normal read mode:
//! Takes in a size 3 array of floats and updates its measurements of the
//! three magnetic axes in mT. (order XYZ)
//!
//! INPUT ARRAY MUST BE SIZE 3 (or at least have meas_arr to meas_arr + 2 within scope)
//!
//! DOES NOT WORK IN SPECIAL READ MODE [DATA_TYPE field at 0x028-6 does not equal 000b]
//****************************************************************************
void getMagMeasurementsNrml( float meas_arr[] )
{

    uint8_t i;

    // Array to store ranges for coordinates in the order XYZ
    uint16_t ranges[3] = {50,50,50}; // The default value for coordinate ranges is 50 mT (A1)
    ranges[0] = getXrange();
    ranges[1] = getYrange();
    ranges[2] = getZrange();

    int16_t data;

    for (i=0; i<3; ++i)
    {
        data = normalReadRegister(X_CH_RESULT_ADDRESS + i); // read in
        meas_arr[i] = (((float) data) / 32768) * ranges[i];
    }
}





//****************************************************************************
//****************************************************************************
//
// Get Range Functions
//
//****************************************************************************
//****************************************************************************


//****************************************************************************
//! Get and return the integer value of the X_RANGE bits for an axis
//!
//! Returns an unsigned 16-bit integer value of the X axis range in mT.
//****************************************************************************
uint16_t getXrange()
{
    // Get SENSOR_CONFIG and isolate X_RANGE bits.
    uint16_t config = normalReadRegister(SENSOR_CONFIG_ADDRESS) & SENSOR_CONFIG_X_RANGE_MASK;
    uint16_t range;
    if ( getVersion() == 1 )
    {
        // range values for TMAG5170A2
        range = 150;
        if ( config == 0x0001 ) range = 75; // If examined bits equal 01b, range is set to 75 mT (for A2)
        else if ( config == 0x0002 ) range = 300; // If examined bits equal 10b, range is set to 300 mT (for A2)
    }
    else
    {
        // range values for TMAG5170A1
        range = 50;
        if ( config == 0x0001  ) range = 25; // If examined bits equal 01b, range is set to 25 mT (for A1)
        else if ( config == 0x0002 ) range = 100; // If examined bits equal 10b, range is set to 100 mT (for A1)
    }
    return range;
}


//****************************************************************************
//! Get and return the integer value of the Y_RANGE bits for an axis
//!
//! Returns an unsigned 16-bit integer value of the Y axis range in mT.
//****************************************************************************
uint16_t getYrange()
{
    // Get SENSOR_CONFIG and isolate Y_RANGE bits, shifting them to LSB.
    uint16_t config = normalReadRegister(SENSOR_CONFIG_ADDRESS) & SENSOR_CONFIG_Y_RANGE_MASK >> 2;
    uint16_t range;
    if ( getVersion() == 1 )
    {
        // range values for TMAG5170A2
        range = 150;
        if ( config == 0x0001  ) range = 75; // If examined bits equal 01b, range is set to 75 mT (for A2)
        else if ( config == 0x0002 ) range = 300; // If examined bits equal 10b, range is set to 300 mT (for A2)
    }
    else
    {
        // range values for TMAG5170A1
        range = 50;
        if ( config == 0x0001  ) range = 25; // If examined bits equal 01b, range is set to 25 mT (for A1)
        else if ( config == 0x0002 ) range = 100; // If examined bits equal 10b, range is set to 100 mT (for A1)
    }
    return range;
}


//****************************************************************************
//! Get and return the integer value of the Z_RANGE bits for an axis
//!
//! Returns an unsigned 16-bit integer value of the Z axis range in mT.
//****************************************************************************
uint16_t getZrange()
{
    // Get SENSOR_CONFIG and isolate Z_RANGE bits, shifting them to LSB.
    uint16_t config = normalReadRegister(SENSOR_CONFIG_ADDRESS) & SENSOR_CONFIG_Z_RANGE_MASK >> 4;
    uint16_t range;
    if ( getVersion() == 1 )
    {
        // range values for TMAG5170A2
        range = 150;
        if ( config == 0x0001  ) range = 75; // If examined bits equal 01b, range is set to 75 mT (for A2)
        else if ( config == 0x0002 ) range = 300; // If examined bits equal 10b, range is set to 300 mT (for A2)
    }
    else
    {
        // range values for TMAG5170A1
        range = 50;
        if ( config == 0x0001  ) range = 25; // If examined bits equal 01b, range is set to 25 mT (for A1)
        else if ( config == 0x0002 ) range = 100; // If examined bits equal 10b, range is set to 100 mT (for A1)
    }
    return range;
}










return 0;
}


/**
 * main.c
 */
int main(void)
{
	WDTCTL = WDTPW | WDTHOLD;	// stop watchdog timer
	
	return 0;
}
